<script setup lang="ts">
import HorizontalCard from "@/components/atoms/card/horizontal-card/HorizontalCard.vue";
import Flex from "@/components/atoms/container/Flex.vue";
import {computed, onUnmounted, ref} from "vue";
import MergeRequest from "@/entities/MergeRequest/MergeRequest";
import {useMergeRequestListStore} from "@/stores/MergeRequest/MergeRequestListStore";
import {useShortcutsListenerStore} from "@/stores/Shortcuts/ShortcutsListenerStore";
import VerticalSeparator from "@/components/atoms/separator/VerticalSeparator.vue";
import MergeRequestRightPart from "@/components/organisms/card/horizontal-card/MergeRequest/MergeRequestRightPart.vue";
import MergeRequestLeftPart from "@/components/organisms/card/horizontal-card/MergeRequest/MergeRequestLeftPart.vue";
import {findShortcutWithShortcutEnum, SHORTCUTS} from "@/constants/SHORTCUTS_PER_SECTION";

const props = defineProps<{
  mergeRequest: MergeRequest,
  processMergeRequestHandler?: Function,
  updateMergeRequestHandler?: Function,
  disabled?: undefined|Boolean
}>()

const mergeRequestList = useMergeRequestListStore();
const shortcutsListener = useShortcutsListenerStore();
const code = ref(props.mergeRequest?.code ?? null);
const validateMergeRequestShortcut = computed(() => findShortcutWithShortcutEnum(SHORTCUTS.VALIDATE_MR));

function processedMergeRequestShortcut(event: KeyboardEvent) {
  if (validateMergeRequestShortcut.value?.isValidEvent(event)) {
    processMergeRequest();
  }
}

function processMergeRequest() {
  if (!props.processMergeRequestHandler) {
    return;
  }

  props.processMergeRequestHandler(props.mergeRequest);
}

const hasFocus = computed(() => {
  if (mergeRequestList.mergeRequestWithFocus === (code.value)) {
    shortcutsListener.addListener(processedMergeRequestShortcut);
    return true;
  }

  shortcutsListener.removeListener(processedMergeRequestShortcut);
  return false;
})

function onClick(): void {
  mergeRequestList.setFocusOnMergeRequest(code.value ?? null);
}

onUnmounted(() => {
  shortcutsListener.removeListener(processedMergeRequestShortcut);
})
</script>

<template>
  <HorizontalCard
      :class="hasFocus ? '!bg-gray-100' : ''"
      @click="onClick"
  >
    <Flex class="grow">
      <MergeRequestLeftPart
          :disabled="disabled"
          :hasFocus="hasFocus"
          :mergeRequest="mergeRequest"
          :updateMergeRequestHandler="updateMergeRequestHandler"
      />
      <VerticalSeparator/>
      <MergeRequestRightPart
          :disabled="disabled"
          :hasFocus="hasFocus"
          :mergeRequest="mergeRequest"
          :updateMergeRequestHandler="updateMergeRequestHandler"
          :processMergeRequestHandler="processMergeRequestHandler"
      />
    </Flex>
  </HorizontalCard>
</template>
